.container {
	margin: 20px;
	display: grid;
	/* grid-template-columns: 15rem 15rem; */
	/* grid-template-columns: repeat(2, 15rem); */
  
  /* En css grid existe otra propiedad para generar dinamicamente columnas en base al contenido que tengamos
  en nuestra página, y es auto-fit y autofill, la diferencia entre ellos es sútil pero se nota */
  /* Primero tenemos autofill, lo que hará autofill es ajustar dinámicamente la cantidad de columnas para
  hacer que los elementos hijos de nuestro container grid se posicionen cada uno en una
  si queremos que se posicione en mas de una columna asignamos a ese elemento la propiedad
  grid-column:auto / span 2
  el ejemplo de arriba ayuda a que tome 2 columnas pero si queremos que tome más solo cambiamos el 2 por
  otro número.
  Volviendo con la explicación de autofill, este va a crear columnas vacías necesarias de la medida que asignemos
  para cubrir todo el ancho del grid disponible; la diferencia con autofit esque autofit no creará nuevas columnas aunque
  el espacio sea suficiente, en caso de que esta columna que se vaya a crear vaya a quedar vacía, se suele usar en combinación
  con min max y debajo se explica porqué.
  columnas */
  /* grid-template-columns: repeat(auto-fill, 10rem); */
  grid-template-columns: repeat(3, 10rem);
  /* Autofit y autofill se usan en combinación mayormente con minmax para asignar valores minimos y máximos de ancho de columnas
  Si tenemos por ejemplo asignado en nuestras columnas que el tamaño mínimo de cada columna es de 10 rem y un máximo de 1fr y tenemos
  autofit, al llegar al máximo valor y que no haya mas elementos que permitan seguir agregando columnas, el tamaño de las columnas
  que ya tenemos seguirá creciendo y siempre usará 1fr del ancho total, a diferencia de autofill, autofill a pesar de que no haya mas elementos
  que permitan agregar nuevas columnas y posicionar esos elementos sobre ellas, creará las nuevas columnas dejándolas vacias.*/
  /* La creación de columnas se hará siempre que no se pueda cumplir en este caso la restricción que agregamos despues del autofit que es
  crear una columna con un ancho mínimo de 10rem, esa restricción tendrá efectos distintos dependiendo si tenemos auto-fit o auto-fill */
    /* Autofill: Seguira creando una columna nueva siempre que el espacio mínimo que se necesita para crear columnas esté disponible 
    aunque ya no haya elementos para posicionar en las nuevas columnas o todos los elementos ya hayan sido posicionados. */
  /* grid-template-columns: repeat(auto-fit, minmax(10rem,1fr)); */
  /* max-width */
	/* apesar de que no estamos creando ningún renglón de forma explícita, grid posicionará
    los elementos hijos del grid, como nuevos rows, con altura automática que dependerá del contenido
    de cada elemento, o sea de cada row */
    /* Autofit ya no creará nuevas columnas aunque haya el espacio mínimo necesario para crear más, en vez de eso tomará el valor máximo y ajustará
    todos los anchos de columnas a ese, siempre que esté disponible, si es un ancho fijo y ya no se pueden expandir ni seguir creando nuevos elementos,
    el contenido del renglón se centrará verticalmente. */
    /* En esencia la diferencia principal radica entre una y otro es que uno sigue agregando nuevas columnas aunque ya no haya elementos por agregar 
    y el otro no */
	justify-content: center;
	grid-gap: 1.5rem;
	/* para el caso de que nuestro grid cree automáticamente los rows, esto es cuando no definimos alturas para rows, o
nuestros elementos del grid se desbordan de modo que se crea un nuevo row, el tamaño por defecto es auto como comentamos 
anteriormente, pero podemos cambiar este comportamiento asignando una altura definida a nuestros rows que se crean de forma 
automática */

	/* con esta propiedad: grid-auto-rows cada nuevo row que se cree de forma automática, es decir sin altura fija
tendrá una altura por defecto de 30rem y no será auto, es decir que si su contenido es mayor a 30rem se desbordará igualmente
pero si es menor a 30rem, se asignará el valor de 30rem aún así */
	/* grid-auto-rows: 30rem; */
	/* es una herramienta muy util para si queremos que por ejemplo nuestros renglones del grid
  tengan una altura fija */
	/* grid-auto-rows: 12rem; */
	/* podemos tambien usar la funcion minmax para definir nuestros valores minimos y máximos
  en este caso podemos asignar un valor minimo fijo y definir que en caso de que crezca el contenido más allá
  usar el auto para ajustarnos a su nueva altura */
	grid-auto-rows: minmax(8rem, auto);

	/* si queremos que nuestro nuevo contenido agregado a nuestro contendor en vez de crear nuevos renglones, cree nuevas columnas, modificamos
  nuestra propiedad grid-auto-flow y la pasamos de row a column, de este modo los nuevos elementos que agreguemos van a crear nuevas columnas
  en vez de renglones */
	/* el comportamiento o valor por defecto es que los elementos hijos que agreguemos a nuestro grid, creen nuevos renglones, notar que
  aun podemos agregar nuevos renglones a nuestro grid, pero de forma manual, ya que con esa modificación los nuevos hijos que agreguemos
  a nuestro grid-container, crearán nuevas columnas */
	/* grid-auto-flow: column; */
	/* del mismo modo que asignamos los tamaños de los renglones agregados al grid de forma automática, podemos asignar los de las columnas
y esto se logra con la propiedad grid-auto-columns con la cual se define un ancho fijo que tendrán todas las columnas, creadas de forma 
automática y por forma automática nos referimos a las creadas cuando agregamos nuevos hijos a nuestro container que ocasionen que se creen
nuevas columnas, en este caso para que ese sea el caso debemos tener el flujo de nuestro grid a columna en vez del valor
por defecto row, y en este ancho de columnas podemos usar los mismos valores de medidas que usamos en css grid  */
	grid-auto-columns: 5rem;

  /* cambiamos de nuevo a row porque nos servirá más adelante */
  /*Nota importante: Como observación si usamos autoflow con columns y tenemos mas de un renglon declarado
  los elementos primero se intentarán colocar en estos renglones establecidos previamente y despues que se llenen
  pasará a colocarlos en una nueva columna al lado de la anterior, notar que con auto flow en columns no se crearán nuevos renglones
  sino nuevas columnas que poblarán cada uno de los renglones ya creados */
  /* css grid tiene otra funcionalidad interesante, puede que nuestra estructura de css grid permita que queden espacios vacios al lado
  de nuestros elementos, por la forma en que se agregan los renglones, donde se respeta el orden en el que van apareciendo
  los elementos en el dom, existe una forma de que css rellene esos espacios segun crea conveniente si despues del elemento a agregar
  hay un elemento que pueda llenra dicho espacio,dicho de otro modo dense, nos ayuda a que sin importar el orden del dom de nuestro
  grid, se apilen todos los elementos según haya espacio disponible */
	grid-auto-flow: row dense;

  /* grid-template-rows:20rem; */

  /* Nota:
  En css grid hay 2 términos a considerar, el grid implícito y el grid explícito, todo el tema explícito es lo que
  abarca los rows y columns que declaramos al usar nuestros templates, el tema implícito son los rows que se van a crear al momento
  de que se agreguen nuevos hijos a nuestro grid container.
  Dicho de otro modo lo explícito son los renglones y columnas que manualmente declaramos, es decir si por ejemplo tenemos 2 renglones y 3 columnas
  al final tendremos un área explicita de 6 celdas únicamente, si se agregan nuevas celdas ya estamos hablando de áreas ímplicitas
  que se agregarán automáticamente al grid dependiendo de la configuración que tengamos establecida.
  */
}

.quote {
	border: 1px solid #fa923f;
	background: #ffbd87;
	font-family: sans-serif;
	padding: 1rem;
	border-radius: 5px;
}

/* agregamos un span de 2 a nuestro segundo elemento quote y ajustamos las columnas a 3, de este modo
ya que el primer elemento y el segundo elemento del dom ocupan ambos 2 celdas, quedará un espacio al lado del primer elemento
que no se llenará porque se está respetando el orden de apilamiento del dom para agregar los renglones, para llenar
este espacio es que asignamos el autoflow a row dense, de modo que el elemento que va despues de este elemento nth que es de 1 columna de 
ancho, se pueda colocar al lado del primer elemento que es de 2 columnas de ancho, para poder llenar las 3 columnas y no dejar ninguna vacía */
.quote:nth-of-type(2){
  grid-column: span 2;
}

.quote--featured {
	border: #ff4213;
	background: #ff9f87;
	grid-column: span 2;
}

